﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Data;
using System.Data.SqlClient;

namespace FromTSV2SQL
{
    public class Program
    {
        public static string DATA_SERVER = "UKARTOUN-PC\\MSSQLSERVER2012"; // Your computer name and server
        public static string DATABASE = "SNP_DB";
        public static string pathAndFileName = "D:\\Temp\\dest\\dbSNPAnnotated-HG00733-200-37-ASM.tsv"; //~5GB - download files from http://www.completegenomics.com/

        static void Main(string[] args)
        {
            List<DBRecord> records = new List<DBRecord>();
            int numRowsToInsertAtATime = 100000;            

            FileInfo fileIn = new FileInfo(pathAndFileName);

            StreamReader reader = fileIn.OpenText();
            string[] lineIn;

            int counter = 0;

            while (!reader.EndOfStream)
            {
                lineIn = reader.ReadLine().Split('\t');

                DBRecord dbr = new DBRecord();

                if (lineIn.Count() > 0)
                {
                    dbr.DbSnpId = lineIn[0];
                }
                if (lineIn.Count() > 1)
                {
                    dbr.Alleles = lineIn[1];
                }
                if (lineIn.Count() > 2)
                {
                    dbr.Chromosome = lineIn[2];
                }
                if (lineIn.Count() > 3)
                {
                    dbr.Begin = lineIn[3];
                }
                if (lineIn.Count() > 4)
                {
                    dbr.End = lineIn[4];
                }
                if (lineIn.Count() > 5)
                {
                    dbr.Reference = lineIn[5];
                }
                if (lineIn.Count() > 6)
                {
                    dbr.AlleleAGenotype = lineIn[6];
                }
                if (lineIn.Count() > 7)
                {
                    dbr.AlleleBGenotype = lineIn[7];
                }
                if (lineIn.Count() > 8)
                {
                    dbr.Loci = lineIn[8];
                }
                if (lineIn.Count() > 9)
                {
                    dbr.Zygosity = lineIn[9];
                }
                if (lineIn.Count() > 10)
                {
                    dbr.VarTypeA = lineIn[10];
                }
                if (lineIn.Count() > 11)
                {
                    dbr.HapA = lineIn[11];
                }
                if (lineIn.Count() > 12)
                {
                    dbr.VarScoreVAFA = lineIn[12];
                }
                if (lineIn.Count() > 13)
                {
                    dbr.VarScoreEAFA = lineIn[13];
                }
                if (lineIn.Count() > 14)
                {
                    dbr.ChromosomeA = lineIn[14];
                }
                if (lineIn.Count() > 15)
                {
                    dbr.BeginA = lineIn[15];
                }
                if (lineIn.Count() > 16)
                {
                    dbr.EndA = lineIn[16];
                }
                if (lineIn.Count() > 17)
                {
                    dbr.VarTypeB = lineIn[17];
                }
                if (lineIn.Count() > 18)
                {
                    dbr.HapB = lineIn[18];
                }
                if (lineIn.Count() > 19)
                {
                    dbr.VarScoreVAFB = lineIn[19];
                }
                if (lineIn.Count() > 20)
                {
                    dbr.VarScoreEAFB = lineIn[20];
                }
                if (lineIn.Count() > 21)
                {
                    dbr.ChromosomeB = lineIn[21];
                }
                if (lineIn.Count() > 22)
                {
                    dbr.BeginB = lineIn[22];
                }
                if (lineIn.Count() > 23)
                {
                    dbr.EndB = lineIn[23];
                }
                if (lineIn.Count() > 24)
                {
                    dbr.ThousandGenomesProjectMinorAllele1 = lineIn[24];
                }
                if (lineIn.Count() > 25)
                {
                    dbr.ThousandGenomesProjectMAF1 = lineIn[25];
                }

                records.Add(dbr);

                counter++;

                if (counter == numRowsToInsertAtATime)
                {
                    InsertRows(records);

                    counter = 0;
                    records = new List<DBRecord>();
                }
            }           

            reader.Close();
        }

        public static DataRow dr;
        public static DataTable listRows;

        public static void InsertRows(List<DBRecord> records)
        {
            listRows = new DataTable();
            listRows.Columns.Add("dbSnpId", typeof(String));
            listRows.Columns.Add("alleles", typeof(String));
            listRows.Columns.Add("chromosome", typeof(String));
            listRows.Columns.Add("begin", typeof(String));
            listRows.Columns.Add("end", typeof(String));
            listRows.Columns.Add("reference", typeof(String));
            listRows.Columns.Add("alleleAGenotype", typeof(String));
            listRows.Columns.Add("alleleBGenotype", typeof(String));
            listRows.Columns.Add("loci", typeof(String));
            listRows.Columns.Add("zygosity", typeof(String));
            listRows.Columns.Add("varTypeA", typeof(String));
            listRows.Columns.Add("hapA", typeof(String));
            listRows.Columns.Add("varScoreVAFA", typeof(String));
            listRows.Columns.Add("varScoreEAFA", typeof(String));
            listRows.Columns.Add("chromosomeA", typeof(String));
            listRows.Columns.Add("beginA", typeof(String));
            listRows.Columns.Add("endA", typeof(String));
            listRows.Columns.Add("varTypeB", typeof(String));
            listRows.Columns.Add("hapB", typeof(String));
            listRows.Columns.Add("varScoreVAFB", typeof(String));
            listRows.Columns.Add("varScoreEAFB", typeof(String));
            listRows.Columns.Add("chromosomeB", typeof(String));
            listRows.Columns.Add("beginB", typeof(String));
            listRows.Columns.Add("endB", typeof(String));
            listRows.Columns.Add("SThousandGenomesProjectMinorAllelenpId", typeof(String));
            listRows.Columns.Add("ThousandGenomesProjectMAF", typeof(String));

            foreach (var val in records)
            {
                dr = listRows.NewRow();
                dr["dbSnpId"] = val.DbSnpId.ToString();
                dr["alleles"] = val.Alleles.ToString();
                dr["chromosome"] = val.Chromosome.ToString();
                dr["begin"] = val.Begin.ToString();
                dr["end"] = val.End.ToString();
                dr["reference"] = val.Reference.ToString();
                dr["alleleAGenotype"] = val.AlleleAGenotype.ToString();
                dr["alleleBGenotype"] = val.AlleleBGenotype.ToString();
                dr["loci"] = val.Loci.ToString();
                dr["zygosity"] = val.Zygosity.ToString();
                dr["varTypeA"] = val.VarTypeA.ToString();
                dr["hapA"] = val.HapA.ToString();
                dr["varScoreVAFA"] = val.VarScoreVAFA.ToString();
                dr["varScoreEAFA"] = val.VarScoreEAFB.ToString();
                dr["chromosomeA"] = val.ChromosomeA.ToString();
                dr["beginA"] = val.BeginA.ToString();
                dr["endA"] = val.EndA.ToString();
                dr["varTypeB"] = val.VarTypeB.ToString();
                dr["hapB"] = val.HapB.ToString();
                dr["varScoreVAFB"] = val.VarScoreVAFB.ToString();
                dr["varScoreEAFB"] = val.VarScoreEAFB.ToString();
                dr["beginB"] = val.BeginB.ToString();
                dr["endB"] = val.EndB.ToString();
                dr["SThousandGenomesProjectMinorAllelenpId"] = val.ThousandGenomesProjectMinorAllele1.ToString();
                dr["ThousandGenomesProjectMAF"] = val.ThousandGenomesProjectMAF1.ToString();   
                
                listRows.Rows.Add(dr);
            }

            SqlConnection bulkSqlConnector =
                new SqlConnection("integrated security=SSPI;persist security info=False;Trusted_Connection=Yes;server="
                    + DATA_SERVER + ";" + "database=" + DATABASE + ";connection timeout=0");

            using (SqlConnection connection = bulkSqlConnector)
            {
                connection.Open();

                using (SqlBulkCopy bulkcopy = new SqlBulkCopy(connection))
                {
                    StringBuilder currentTrackingTableNameSB = new StringBuilder();
                    currentTrackingTableNameSB.Append("SNPTable");                   

                    bulkcopy.DestinationTableName = "dbo." + currentTrackingTableNameSB.ToString();
                    bulkcopy.BulkCopyTimeout = 30;

                    try
                    {
                        bulkcopy.WriteToServer(listRows);
                    }
                    catch (Exception ex)
                    {
                        //  throw ex;
                    }

                    connection.Close();
                }
            }
        }        
    }
}
